#include    "main.h"

void initSpeedRA (struct RegisterAxis *axis){
	if(axis->Enable) EN_RA_DW;
	switch (axis->Mode){
	case 0: case 1: {DIR_RA_UP; TIM17->PSC = 160 - 1; TIM17->ARR = axis->Speed; break;}
	case 2: case 3: {DIR_RA_DW; TIM17->PSC = 160 - 1; TIM17->ARR = axis->Speed; break;}
	case 4: case 5: {DIR_RA_UP; TIM17->ARR = axis->Speed; break;}
	case 6: case 7: {DIR_RA_DW; TIM17->ARR = axis->Speed; break;}
	}
}

void initSpeedDEC (struct RegisterAxis *axis){
	if(axis->Enable) EN_DEC_DW;
	switch (axis->Mode){
	case 0: case 1: {DIR_DEC_UP; TIM16->PSC = 160 - 1; TIM16->ARR = axis->Speed; break;}
	case 2: case 3: {DIR_DEC_DW; TIM16->PSC = 160 - 1; TIM16->ARR = axis->Speed; break;}
	case 4: case 5: {DIR_DEC_UP; TIM16->ARR = axis->Speed; break;}
	case 6: case 7: {DIR_DEC_DW; TIM16->ARR = axis->Speed; break;}
	}
}

void encoderGoto (struct RegisterAxis *axis){
	switch (axis->Mode){
	case 1: case 5: {axis->Encoder++; break;}
	case 3: case 7: {axis->Encoder--; break;}
	case 0: {
		axis->Encoder++;
		if (axis->Encoder >= axis->Goto) {axis->ControlON = 0; axis->GotoAction = 0;}
		break;
	}
	case 2: {
		axis->Encoder--;
		if (axis->Encoder <= axis->Goto) {axis->ControlON = 0; axis->GotoAction = 0;}
		break;
	}
	case 4: {
		axis->Encoder++;
		if (axis->Encoder >= (axis->Goto - 0x1C00)) {axis->ControlON = 0; axis->GotoAction = 0;}
		break;
	}
	case 6: {
		axis->Encoder--;
		if (axis->Encoder <= (axis->Goto + 0x1C00)) {axis->ControlON = 0; axis->GotoAction = 0;}
	}
	}
}

void slowStartStop(struct RegisterAxis *axis, u16 volatile *Timer){
	
	if (axis->ControlON){
		switch (axis->Mode){
		case 0: case 2: axis->GotoAction = 1;
		case 1: case 3: {axis->StatusON = 1; break;}
		case 4: case 6: axis->GotoAction = 1;
		case 5: case 7: {
			axis->StatusON = 1;
			if(((*Timer) > 10-1) && (axis->Temp <= SysTickTime)){
				(*Timer)--;
				axis->Temp = SysTickTime + 10;
			}
			break;
			
		}
		}
	}
	else {
		switch (axis->Mode){
		case 0: case 1: case 2: case 3: {axis->StatusON = 0; break;}
		case 5: case 7: {
			if((*Timer) < 160-1){
			   if(axis->Temp <= SysTickTime){
				(*Timer)++;
				axis->Temp = SysTickTime + 10;
			   }
			}
			else {axis->StatusON = 0;}
			break;
		}
		case 4: {
			if((*Timer) < 160-1){
			   if(axis->Temp <= SysTickTime){
				(*Timer)++;
				axis->Temp = SysTickTime + 10;
			   }
			} 
			else {
				if(!axis->GotoAction && axis->StatusON) {axis->ControlON = 1; axis->Mode = 0;}
				else {axis->StatusON = 0; axis->Mode = 1; axis->GotoAction = 0;}
			}
			break;
		}
		case 6: {
			if((*Timer) < 160-1){
			   if(axis->Temp <= SysTickTime){
				(*Timer)++;
				axis->Temp = SysTickTime + 10;
			   }
			} 
			else {
				if(!axis->GotoAction && axis->StatusON) {axis->ControlON = 1; axis->Mode = 2;}
				else {axis->StatusON = 0; axis->Mode = 3; axis->GotoAction = 0;}
			}
			break;
		}
		}
	}
}
